<p align="center">
  <img src="art/logo.png" alt="nestjs-firebase-admin logo" width="200">
</p>

<p align="center">
  <a href="https://codecov.io/gh/hebertcisco/nestjs-firebase-admin">
    <img src="https://codecov.io/gh/hebertcisco/nestjs-firebase-admin/branch/main/graph/badge.svg?token=N0IW1UNNIP" alt="codecov">
  </a>
  <a href="https://dl.circleci.com/status-badge/redirect/gh/hebertcisco/nestjs-firebase-admin/tree/main">
    <img src="https://dl.circleci.com/status-badge/img/gh/hebertcisco/nestjs-firebase-admin/tree/main.svg?style=svg" alt="CircleCI">
  </a>
  <a href="https://github.com/hebertcisco/nestjs-firebase-admin/actions/workflows/npm-publish.yml">
    <img src="https://github.com/hebertcisco/nestjs-firebase-admin/actions/workflows/npm-publish.yml/badge.svg" alt="Node.js build and publish package">
  </a>
  <a href="https://github.com/hebertcisco/nestjs-firebase-admin/actions/workflows/coverage.yml">
    <img src="https://github.com/hebertcisco/nestjs-firebase-admin/actions/workflows/coverage.yml/badge.svg" alt="Running Code Coverage">
  </a>
  <img src="https://img.shields.io/badge/TypeScript-007ACC?style=flat&logo=typescript&logoColor=white" alt="TypeScript">
  <img src="https://img.shields.io/badge/Nestjs-ea2845?style=flat&logo=nestjs&logoColor=white" alt="Nestjs">
  <img src="https://img.shields.io/badge/VS_Code-0078D4?style=flat&logo=visual%20studio%20code&logoColor=white" alt="VS Code">
  <img src="https://img.shields.io/badge/github%20actions-%232671E5.svg?style=flat&logo=githubactions&logoColor=white" alt="GitHub Actions">
</p>

> Firebase Admin SDK for NestJS :fire:

## Requirements

- **Node.js**: >= 20
- **NPM**: >= 10
- **NestJS**: >= 7.0.0

## Installation

Install the package using `yarn`, `npm`, or `pnpm`:

```bash
# yarn
yarn add nestjs-firebase-admin
```

```bash
# npm
npm i nestjs-firebase-admin --save
```

```bash
# pnpm
pnpm add nestjs-firebase-admin --save
```

## Testing

To run tests, use the following commands:

### Unit Tests

```bash
npm test
```

### Coverage Tests

```bash
npm run test:cov
```

### Watch Mode Tests

```bash
npm run test:watch
```

### Debug Tests

```bash
npm run test:debug
```

## Available Scripts

The available scripts in `package.json` include:

- **Build**: `npm run build`
- **Lint**: `npm run lint`
- **Format**: `npm run format`
- **Release**: `npm run release`

## Contributing

Contributions, issues, and feature requests are welcome!<br />Feel free to check the [issues page](https://github.com/hebertcisco/nestjs-firebase-admin/issues).

## Show Your Support

Give a ⭐️ if this project helped you!

Or buy the author a coffee 🙌🏾

<a href="https://www.buymeacoffee.com/hebertcisco">
    <img src="https://img.buymeacoffee.com/button-api/?text=Buy me a coffee&emoji=&slug=hebertcisco&button_colour=FFDD00&font_colour=000000&font_family=Inter&outline_colour=000000&coffee_colour=ffffff" />
</a>

## 📝 License

This project is under the [MIT](LICENSE) license.
