"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var AdminModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminModule = void 0;
const common_1 = require("@nestjs/common");
const random_string_generator_util_1 = require("@nestjs/common/utils/random-string-generator.util");
const firebase_admin_1 = __importDefault(require("firebase-admin"));
const admin_constants_1 = require("./constants/admin.constants");
const admin_service_1 = require("./services/admin.service");
const database_service_1 = require("./services/database.service");
const messaging_service_1 = require("./services/messaging.service");
const firestore_service_1 = require("./services/firestore.service");
const auth_service_1 = require("./services/auth.service");
let AdminModule = AdminModule_1 = class AdminModule {
    static register(options) {
        const firebaseApp = firebase_admin_1.default.initializeApp(Object.assign(Object.assign({}, options), { credential: firebase_admin_1.default.credential.cert(options.credential) }));
        return {
            module: AdminModule_1,
            providers: [
                {
                    provide: admin_constants_1.ADMIN_MODULE_OPTIONS,
                    useValue: options,
                },
                admin_service_1.AdminService,
                database_service_1.DatabaseService,
                messaging_service_1.MessagingService,
                firestore_service_1.FirestoreService,
                auth_service_1.AuthService,
                {
                    provide: admin_constants_1.FIREBASE_ADMIN_INSTANCE_TOKEN,
                    useValue: options,
                },
                {
                    provide: admin_constants_1.FIREBASE_ADMIN_APP,
                    useValue: firebaseApp,
                },
                {
                    provide: admin_constants_1.ADMIN_MODULE_ID,
                    useValue: (0, random_string_generator_util_1.randomStringGenerator)(),
                },
            ],
            exports: [
                admin_service_1.AdminService,
                database_service_1.DatabaseService,
                messaging_service_1.MessagingService,
                firestore_service_1.FirestoreService,
                auth_service_1.AuthService,
                admin_constants_1.FIREBASE_ADMIN_INSTANCE_TOKEN,
                admin_constants_1.FIREBASE_ADMIN_APP,
            ],
        };
    }
    static registerAsync(options) {
        if (!options.useFactory) {
            throw new Error('useFactory is required in registerAsync options');
        }
        const providers = [
            {
                provide: admin_constants_1.ADMIN_MODULE_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            },
            admin_service_1.AdminService,
            database_service_1.DatabaseService,
            messaging_service_1.MessagingService,
            firestore_service_1.FirestoreService,
            auth_service_1.AuthService,
            {
                provide: admin_constants_1.ADMIN_MODULE_ID,
                useValue: (0, random_string_generator_util_1.randomStringGenerator)(),
            },
        ];
        if (options.useFactory) {
            const factory = options.useFactory;
            providers.push({
                provide: admin_constants_1.FIREBASE_ADMIN_INSTANCE_TOKEN,
                useFactory: factory,
                inject: options.inject || [],
            });
            providers.push({
                provide: admin_constants_1.FIREBASE_ADMIN_APP,
                useFactory: (...args) => __awaiter(this, void 0, void 0, function* () {
                    const config = yield factory(...args);
                    return firebase_admin_1.default.initializeApp(Object.assign(Object.assign({}, config), { credential: firebase_admin_1.default.credential.cert(config.credential) }));
                }),
                inject: options.inject || [],
            });
        }
        else if (options.useExisting) {
            providers.push({
                provide: admin_constants_1.FIREBASE_ADMIN_INSTANCE_TOKEN,
                useFactory: (optionsFactory) => __awaiter(this, void 0, void 0, function* () {
                    const config = yield optionsFactory.createAdminOptions();
                    return config;
                }),
                inject: [options.useExisting],
            });
            providers.push({
                provide: admin_constants_1.FIREBASE_ADMIN_APP,
                useFactory: (optionsFactory) => __awaiter(this, void 0, void 0, function* () {
                    const config = yield optionsFactory.createAdminOptions();
                    return firebase_admin_1.default.initializeApp(Object.assign(Object.assign({}, config), { credential: firebase_admin_1.default.credential.cert(config.credential) }));
                }),
                inject: [options.useExisting],
            });
        }
        else if (options.useClass) {
            providers.push({
                provide: options.useClass,
                useClass: options.useClass,
            });
            providers.push({
                provide: admin_constants_1.FIREBASE_ADMIN_INSTANCE_TOKEN,
                useFactory: (optionsFactory) => __awaiter(this, void 0, void 0, function* () {
                    const config = yield optionsFactory.createAdminOptions();
                    return config;
                }),
                inject: [options.useClass],
            });
            providers.push({
                provide: admin_constants_1.FIREBASE_ADMIN_APP,
                useFactory: (optionsFactory) => __awaiter(this, void 0, void 0, function* () {
                    const config = yield optionsFactory.createAdminOptions();
                    return firebase_admin_1.default.initializeApp(Object.assign(Object.assign({}, config), { credential: firebase_admin_1.default.credential.cert(config.credential) }));
                }),
                inject: [options.useClass],
            });
        }
        else {
            throw new Error('One of useFactory, useExisting, or useClass must be provided in AdminModuleAsyncOptions');
        }
        return {
            module: AdminModule_1,
            imports: options.imports || [],
            providers,
            exports: [
                admin_service_1.AdminService,
                database_service_1.DatabaseService,
                messaging_service_1.MessagingService,
                firestore_service_1.FirestoreService,
                auth_service_1.AuthService,
                admin_constants_1.FIREBASE_ADMIN_INSTANCE_TOKEN,
                admin_constants_1.FIREBASE_ADMIN_APP,
            ],
        };
    }
};
exports.AdminModule = AdminModule;
exports.AdminModule = AdminModule = AdminModule_1 = __decorate([
    (0, common_1.Module)({
        providers: [
            admin_service_1.AdminService,
            database_service_1.DatabaseService,
            messaging_service_1.MessagingService,
            firestore_service_1.FirestoreService,
            auth_service_1.AuthService,
            {
                provide: admin_constants_1.ADMIN_MODULE_ID,
                useValue: (0, random_string_generator_util_1.randomStringGenerator)(),
            },
        ],
        exports: [
            admin_service_1.AdminService,
            database_service_1.DatabaseService,
            messaging_service_1.MessagingService,
            firestore_service_1.FirestoreService,
            auth_service_1.AuthService,
        ],
    })
], AdminModule);
