"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
describe('AdminModuleOptionsFactory', () => {
    it('should define a method to create admin options', () => {
        class TestFactory {
            createAdminOptions() {
                return { credential: { projectId: 'test' } };
            }
        }
        const factory = new TestFactory();
        expect(factory.createAdminOptions()).toEqual({
            credential: { projectId: 'test' },
        });
    });
});
describe('AdminModuleAsyncOptions', () => {
    it('should allow useExisting, useClass, or useFactory for async options', () => {
        const asyncOptions = {
            useFactory: () => __awaiter(void 0, void 0, void 0, function* () { return ({ credential: { projectId: 'test' } }); }),
            inject: [],
        };
        expect(asyncOptions.useFactory).toBeDefined();
        expect(asyncOptions.inject).toEqual([]);
    });
    it('should support extraProviders', () => {
        const extraProvider = { provide: 'TEST', useValue: 'value' };
        const asyncOptions = {
            useFactory: () => __awaiter(void 0, void 0, void 0, function* () { return ({ credential: { projectId: 'test' } }); }),
            inject: [],
            extraProviders: [extraProvider],
        };
        expect(asyncOptions.extraProviders).toContain(extraProvider);
    });
});
