import { Observable } from 'rxjs';
import Admin from 'firebase-admin';
import type { App } from 'firebase-admin/app';
import type { Agent } from 'node:http';
import type { AdminModuleOptions } from '../types';
export declare class AdminService {
    protected readonly options: AdminModuleOptions;
    private readonly firebaseApp;
    private readonly app;
    constructor(options: AdminModuleOptions, firebaseApp: App);
    applicationDefault(httpAgent?: Agent): import("firebase-admin/app").Credential;
    deleteApp(app: App): Promise<void>;
    get getApps(): App[];
    get getApp(): App;
    admin(): typeof Admin;
    initializeAppObservable<T = App>(): Observable<App>;
    get appRef(): App;
    initializeApp(): App;
}
