import { AdminService } from './admin.service';
export declare class AuthService {
    private readonly adminService;
    constructor(adminService: AdminService);
    get auth(): import("firebase-admin/auth").Auth;
    createUser(properties: {
        email?: string;
        emailVerified?: boolean;
        phoneNumber?: string;
        password?: string;
        displayName?: string;
        photoURL?: string;
        disabled?: boolean;
    }): Promise<import("firebase-admin/auth").UserRecord>;
    getUser(uid: string): Promise<import("firebase-admin/auth").UserRecord>;
    getUserByEmail(email: string): Promise<import("firebase-admin/auth").UserRecord>;
    getUserByPhoneNumber(phoneNumber: string): Promise<import("firebase-admin/auth").UserRecord>;
    updateUser(uid: string, properties: {
        email?: string;
        emailVerified?: boolean;
        phoneNumber?: string;
        password?: string;
        displayName?: string;
        photoURL?: string;
        disabled?: boolean;
    }): Promise<import("firebase-admin/auth").UserRecord>;
    deleteUser(uid: string): Promise<void>;
    createCustomToken(uid: string, claims?: object): Promise<string>;
    verifyIdToken(idToken: string): Promise<import("firebase-admin/auth").DecodedIdToken>;
    setCustomUserClaims(uid: string, claims: object): Promise<void>;
    listUsers(maxResults?: number, pageToken?: string): Promise<import("firebase-admin/auth").ListUsersResult>;
}
