"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthService = void 0;
const common_1 = require("@nestjs/common");
const auth_1 = require("firebase-admin/auth");
const admin_service_1 = require("./admin.service");
let AuthService = class AuthService {
    constructor(adminService) {
        this.adminService = adminService;
    }
    get auth() {
        return (0, auth_1.getAuth)(this.adminService.appRef);
    }
    createUser(properties) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.createUser(properties);
        });
    }
    getUser(uid) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.getUser(uid);
        });
    }
    getUserByEmail(email) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.getUserByEmail(email);
        });
    }
    getUserByPhoneNumber(phoneNumber) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.getUserByPhoneNumber(phoneNumber);
        });
    }
    updateUser(uid, properties) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.updateUser(uid, properties);
        });
    }
    deleteUser(uid) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.deleteUser(uid);
        });
    }
    createCustomToken(uid, claims) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.createCustomToken(uid, claims);
        });
    }
    verifyIdToken(idToken) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.verifyIdToken(idToken);
        });
    }
    setCustomUserClaims(uid, claims) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.setCustomUserClaims(uid, claims);
        });
    }
    listUsers(maxResults, pageToken) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.auth.listUsers(maxResults, pageToken);
        });
    }
};
exports.AuthService = AuthService;
exports.AuthService = AuthService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [admin_service_1.AdminService])
], AuthService);
