import type { AdminModuleOptions } from '../types';
import { App } from 'firebase-admin/app';
export declare class DatabaseService {
    protected readonly options: AdminModuleOptions;
    private readonly firebaseApp;
    private app;
    private database;
    constructor(options: AdminModuleOptions, firebaseApp: App);
    ref(path: string): import("@firebase/database-types").Reference;
    get<T>(path: string): Promise<T>;
    set<T>(path: string, data: T): Promise<void>;
    update<T>(path: string, data: Partial<T>): Promise<void>;
    remove(path: string): Promise<void>;
    push<T>(path: string, data: T): Promise<string>;
}
