import { CollectionReference, DocumentReference, DocumentData, SetOptions, WithFieldValue } from 'firebase-admin/firestore';
import type { AdminModuleOptions } from '../types';
import { App } from 'firebase-admin/app';
export declare class FirestoreService {
    protected readonly options: AdminModuleOptions;
    private readonly firebaseApp;
    private app;
    private firestore;
    constructor(options: AdminModuleOptions, firebaseApp: App);
    collection<T = DocumentData>(path: string): CollectionReference<T>;
    doc<T = DocumentData>(path: string): DocumentReference<T>;
    get<T = DocumentData>(path: string): Promise<T | null>;
    set<T = DocumentData>(path: string, data: WithFieldValue<T>, options?: SetOptions): Promise<void>;
    update<T = DocumentData>(path: string, data: Record<string, any>): Promise<void>;
    delete(path: string): Promise<void>;
    add<T = DocumentData>(collectionPath: string, data: WithFieldValue<T>): Promise<DocumentReference<T>>;
    query<T = DocumentData>(collectionPath: string, ...constraints: any[]): Promise<T[]>;
}
