"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirestoreService = void 0;
const common_1 = require("@nestjs/common");
const firestore_1 = require("firebase-admin/firestore");
const admin_constants_1 = require("../constants/admin.constants");
let FirestoreService = class FirestoreService {
    constructor(options, firebaseApp) {
        this.options = options;
        this.firebaseApp = firebaseApp;
        this.app = firebaseApp;
        this.firestore = (0, firestore_1.getFirestore)();
    }
    collection(path) {
        return this.firestore.collection(path);
    }
    doc(path) {
        return this.firestore.doc(path);
    }
    get(path) {
        return __awaiter(this, void 0, void 0, function* () {
            const docSnap = yield this.doc(path).get();
            return docSnap.exists ? docSnap.data() : null;
        });
    }
    set(path, data, options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (options) {
                yield this.doc(path).set(data, options);
            }
            else {
                yield this.doc(path).set(data);
            }
        });
    }
    update(path, data) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!data || typeof data !== 'object') {
                throw new Error('Update data must be a non-null object');
            }
            yield this.doc(path).update(data);
        });
    }
    delete(path) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.doc(path).delete();
        });
    }
    add(collectionPath, data) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.collection(collectionPath).add(data);
        });
    }
    query(collectionPath, ...constraints) {
        return __awaiter(this, void 0, void 0, function* () {
            let q = this.collection(collectionPath);
            if (constraints.length) {
                for (const constraint of constraints) {
                    q = constraint(q);
                }
            }
            const snap = yield q.get();
            return snap.docs.map(doc => doc.data());
        });
    }
};
exports.FirestoreService = FirestoreService;
exports.FirestoreService = FirestoreService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(admin_constants_1.FIREBASE_ADMIN_INSTANCE_TOKEN)),
    __param(1, (0, common_1.Inject)('FIREBASE_ADMIN_APP')),
    __metadata("design:paramtypes", [Object, Object])
], FirestoreService);
