"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessagingService = void 0;
const common_1 = require("@nestjs/common");
const admin_constants_1 = require("../constants/admin.constants");
let MessagingService = class MessagingService {
    constructor(app) {
        this.app = app;
        this.messaging = this.app.messaging();
    }
    sendToDevice(token, payload) {
        return __awaiter(this, void 0, void 0, function* () {
            const message = Object.assign({ token }, payload);
            const response = yield this.messaging.send(message);
            return response;
        });
    }
    sendToDevices(tokens, payload) {
        return __awaiter(this, void 0, void 0, function* () {
            const message = Object.assign({ tokens }, payload);
            const response = yield this.messaging.sendMulticast(message);
            return response;
        });
    }
    sendToTopic(topic, payload) {
        return __awaiter(this, void 0, void 0, function* () {
            const message = Object.assign({ topic }, payload);
            const response = yield this.messaging.send(message);
            return response;
        });
    }
    subscribeToTopic(tokens, topic) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield this.messaging.subscribeToTopic(tokens, topic);
            return response;
        });
    }
    unsubscribeFromTopic(tokens, topic) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield this.messaging.unsubscribeFromTopic(tokens, topic);
            return response;
        });
    }
};
exports.MessagingService = MessagingService;
exports.MessagingService = MessagingService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(admin_constants_1.FIREBASE_ADMIN_APP)),
    __metadata("design:paramtypes", [Object])
], MessagingService);
